<?php

// +---------------------------------------------------------------------------+
// | Contact Geeklog Plugin 1.1                                                |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// | Administration page.                                                      |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Author: Tom Willett       - tomw@pigstye.net                              |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');


function putVar($var, $value) {
	return '$_CONTACT_CONF[' . "'" . $var . "'] = '" . $value . "';" . LB;
}

/**
* Main 
*/

// Only let admin users access this page
if (!SEC_hasRights('contact.admin')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Contact options page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_CT02['access_denied']);
    $display .= $LANG_CT02['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 

if ($action == $LANG_CT00['save']) {
	$config = "<";
	$config .= "?php" . LB;
	$config .= '/* Configuration options for Contact Plugin.           */' . LB;
	$config .= '/* Copyright (C) 2002 by the following authors:        */' . LB;
	$config .= '/* Author: Tom Willett       - tomw@pigstye.net        */' . LB;
	$config .= '/* This program is free software; License GPL          */' . LB;
	$config .= '/* Changes to this file may be overwritten by program  */' . LB;
    $config .= putVar('contact_phone1',$phone1);
    $config .= putVar('contact_phone2',$phone2);
	$config .= putVar('contact_email1',$email1);
	$config .= putVar('contact_email2',$email2);
	$config .= putVar('contact_url1',$url1);
	$config .= putVar('contact_url2',$url2);
	$config .= putVar('contact_date1',$date1);
	$config .= putVar('contact_date2',$date2);
	$config .= putVar('contact_user1',$user1);
	$config .= putVar('contact_user2',$user2);
    $config .= putVar('contactc_phone1',$cphone1);
    $config .= putVar('contactc_phone2',$cphone2);
	$config .= putVar('contactc_email1',$cemail1);
	$config .= putVar('contactc_email2',$cemail2);
	$config .= putVar('contactc_url1',$curl1);
	$config .= putVar('contactc_url2',$curl2);
	$config .= putVar('contactc_date1',$cdate1);
	$config .= putVar('contactc_date2',$cdate2);
	$config .= putVar('contactc_user1',$cuser1);
	$config .= putVar('contactc_user2',$cuser2);
	if (empty($anon)) { $anon='0'; } else { $anon='1'; }
	$config .= putVar('contact_anon',$anon);
	$config .= putVar('menu',$menu);
    $config .= '?>';
	$fd=fopen($_CONF['path'] . "plugins/contact/options.php",'w');
	fputs($fd,$config);
	fclose($fd);
	print COM_refresh($_CONF['site_admin_url'] . "/plugins/contact/index.php");
	exit;
}

$display = COM_siteHeader();
$T = new Template($_CONF['path'] . 'plugins/contact/templates');
$T->set_file('admin', 'admin.thtml');
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('header',$LANG_CT03['admin_header']);
$T->set_var('uninstall',$LANG_CT03['uninstall']);
$T->set_var('reindex',$LANG_CT03["reindex"]);
$T->set_var('msg1',$LANG_CT03['admin_msg1']);
$T->set_var('msg2',$LANG_CT03['admin_msg2']);
$T->set_var('site_admin_url',$_CONF['site_admin_url']);
$T->set_var('site_admin', $LANG_CT03['admin_home']);
$T->set_var('anon_msg',$LANG_CT03['anon_msg']);
if ($_CONTACT_CONF['contact_anon'] == 1) {
	$T->set_var('checked','checked ');
}
$T->set_var('menu',$_CONTACT_CONF['menu']);
$T->set_var('menu_label','Menu Title (Blank for no Menu)');
$T->set_var('person',$LANG_CT00['people']);
$T->set_var('company',$LANG_CT00['companies']);
$T->set_var('p1',$LANG_CT01['phone1']);
$T->set_var('p2',$LANG_CT01['phone2']);
$T->set_var('e1',$LANG_CT01['email1']);
$T->set_var('e2',$LANG_CT01['email2']);
$T->set_var('u1',$LANG_CT01['url1']);
$T->set_var('u2',$LANG_CT01['url2']);
$T->set_var('d1',$LANG_CT01['date1']);
$T->set_var('d2',$LANG_CT01['date2']);
$T->set_var('us1',$LANG_CT01['user1']);
$T->set_var('us2',$LANG_CT01['user2']);
$T->set_var('phone1',$_CONTACT_CONF['contact_phone1']);
$T->set_var('phone2',$_CONTACT_CONF['contact_phone2']);
$T->set_var('email1',$_CONTACT_CONF['contact_email1']);
$T->set_var('email2',$_CONTACT_CONF['contact_email2']);
$T->set_var('url1',$_CONTACT_CONF['contact_url1']);
$T->set_var('url2',$_CONTACT_CONF['contact_url2']);
$T->set_var('date1',$_CONTACT_CONF['contact_date1']);
$T->set_var('date2',$_CONTACT_CONF['contact_date2']);
$T->set_var('user1',$_CONTACT_CONF['contact_user1']);
$T->set_var('user2',$_CONTACT_CONF['contact_user2']);
$T->set_var('cphone1',$_CONTACT_CONF['contactc_phone1']);
$T->set_var('cphone2',$_CONTACT_CONF['contactc_phone2']);
$T->set_var('cemail1',$_CONTACT_CONF['contactc_email1']);
$T->set_var('cemail2',$_CONTACT_CONF['contactc_email2']);
$T->set_var('curl1',$_CONTACT_CONF['contactc_url1']);
$T->set_var('curl2',$_CONTACT_CONF['contactc_url2']);
$T->set_var('cdate1',$_CONTACT_CONF['contactc_date1']);
$T->set_var('cdate2',$_CONTACT_CONF['contactc_date2']);
$T->set_var('cuser1',$_CONTACT_CONF['contactc_user1']);
$T->set_var('cuser2',$_CONTACT_CONF['contactc_user2']);
$T->set_var('save',$LANG_CT00['save']);
$T->set_var('cancel',$LANG_CT00['cancel']);
$T->set_var('post_url',$_CONF['site_admin_url'] . '/plugins/contact/index.php');

$T->parse('output','admin');
$display .= $T->finish($T->get_var('output'));

$display .= COM_siteFooter(true);

echo $display;

?>
