<?php

// +---------------------------------------------------------------------------+
// | Contact Plugin 1.1 for Geeklog - The Ultimate Weblog                      |
// +---------------------------------------------------------------------------+
// | install.php                                                               |
// |                                                                           |
// | This file installs and removes the data structures for the Contact        |
// | plugin for Geeklog.                                                       |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// | Based upon the work of Tony Bibbs Static Pages Plugin                     |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');
$langfile = $_CONF['path'] . 'plugins/contact/language/' . $_CONF['language'] . '.php';
if (file_exists ($langfile)) {
    require_once ($langfile);
} else {
    require_once ($_CONF['path'] . 'plugins/contact/language/english.php');
}
require_once($_CONF['path'] . 'plugins/contact/config.php');

// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Contact install/uninstall page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_CT02['access_denied']);
    $display .= $LANG_CT02['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/**
* Puts the datastructures for this plugin into the Geeklog database
*
*/
function plugin_install_contact()
{
    global $_TABLES, $_CONF, $_SP_CONF, $_CONTACT_CONF, $LANG_CT02;

    COM_errorLog('Attempting to install the Contact Plugin',1);

    // Installs the contact plugin

    $createsql = "CREATE TABLE ct_person ("
	. "c_id int(10) NOT NULL Auto_Increment,"
	. "co_id int(10) NOT NULL default '1',"
    . "salutation varchar(15) NOT NULL default '',"
    . "fname varchar(50) NOT NULL default '',"
    . "mname varchar(20) NOT NULL default '',"
    . "lname varchar(40) NOT NULL default '',"
    . "title varchar(15) NOT NULL default '',"
    . "address1 varchar(40) NOT NULL default '',"
    . "address2 varchar(40) NOT NULL default '',"
	. "city varchar(40) NOT NULL default '',"
 	. "state varchar(40) NOT NULL default '',"
	. "postalcode varchar(15) NOT NULL default '',"
	. "country varchar(30) NOT NULL default '',"
	. "phone1 varchar(20) NOT NULL default '',"
	. "phone2 varchar(20) NOT NULL default '',"
	. "fax varchar(20) NOT NULL default '',"
	. "email1 varchar(50) NOT NULL default '',"
  	. "email2 varchar(50) NOT NULL default '',"
	. "url1 varchar(50) NOT NULL default '',"
	. "url2 varchar(50) NOT NULL default '',"
	. "date1 date,"
	. "date2 date,"
	. "user1 varchar (50) NOT NULL default '',"
	. "user2 varchar (50) NOT NULL default '',"
	. "notes text,"
    . "hits mediumint(8) unsigned DEFAULT '0' NOT NULL,"
    . "cdate datetime NOT NULL,"
	. "group_id mediumint(8) unsigned NOT NULL default '1',"
	. "owner_id mediumint(8) unsigned NOT NULL default '1',"
  	. "perm_owner tinyint(1) unsigned NOT NULL default '3',"
  	. "perm_group tinyint(1) unsigned NOT NULL default '3',"
  	. "perm_members tinyint(1) unsigned NOT NULL default '2',"
  	. "perm_anon tinyint(1) unsigned NOT NULL default '2',"
    . "PRIMARY KEY (c_id),"
	. "INDEX (fname),"
	. "INDEX (lname),"
	. "INDEX (city),"
	. "INDEX (state),"
	. "INDEX (country),"
	. "INDEX (phone1)"
    . ")";

    COM_errorLog("Attempting to create table ct_person for contact plugin", 1);
    DB_query($createsql,1);
	DB_query("INSERT INTO ct_person (lname,cdate) VALUES ('" . str_repeat(" ",40) ."', '". time() . "')");
    if (DB_error()) {
        return false;
    }

    COM_errorLog('...success',1);

    $createsql = "CREATE TABLE ct_company ("
	. "c_id int(10) NOT NULL Auto_Increment,"
	. "p_id int(10) NOT NULL default '1',"
    . "name varchar(60) NOT NULL default '',"
    . "address1 varchar(40) NOT NULL default '',"
    . "address2 varchar(40) NOT NULL default '',"
	. "city varchar(40) NOT NULL default '',"
 	. "state varchar(40) NOT NULL default '',"
	. "postalcode varchar(15) NOT NULL default '',"
	. "country varchar(30) NOT NULL default '',"
	. "phone1 varchar(20) NOT NULL default '',"
	. "phone2 varchar(20) NOT NULL default '',"
	. "fax varchar(20) NOT NULL default '',"
	. "email1 varchar(50) NOT NULL default '',"
  	. "email2 varchar(50) NOT NULL default '',"
	. "url1 varchar(50) NOT NULL default '',"
	. "url2 varchar(50) NOT NULL default '',"
	. "date1 date,"
	. "date2 date,"
	. "user1 varchar (50) NOT NULL default '',"
	. "user2 varchar (50) NOT NULL default '',"
	. "notes text,"
    . "hits mediumint(8) unsigned DEFAULT '0' NOT NULL,"
    . "cdate datetime NOT NULL,"
	. "group_id mediumint(8) unsigned NOT NULL default '1',"
	. "owner_id mediumint(8) unsigned NOT NULL default '1',"
  	. "perm_owner tinyint(1) unsigned NOT NULL default '3',"
  	. "perm_group tinyint(1) unsigned NOT NULL default '3',"
  	. "perm_members tinyint(1) unsigned NOT NULL default '2',"
  	. "perm_anon tinyint(1) unsigned NOT NULL default '2',"
    . "PRIMARY KEY (c_id),"
	. "INDEX (name),"
	. "INDEX (city),"
	. "INDEX (state),"
	. "INDEX (country),"
	. "INDEX (phone1)"
    . ")";

    COM_errorLog("Attempting to create table ct_company for contact plugin", 1);
    DB_query($createsql,1);
	DB_query("INSERT INTO ct_company (name,cdate) VALUES ('" . str_repeat(" ",40) ."', '". time() . "')");

    if (DB_error()) {
        return false;
    }

    COM_errorLog('...success',1);

    $createsql = "CREATE TABLE ct_index ("
	. "p_id int(10),"
	. "c_id int(10),"
	. "INDEX (c_id),"
	. "INDEX (p_id)"
	. ")";

    COM_errorLog("Attempting to create table ct_index for contact plugin", 1);
    DB_query($createsql,1);

    if (DB_error()) {
        return false;
    }

    COM_errorLog('...success',1);

    $createsql = "CREATE TABLE ct_user ("
	. "u_id int(10) NOT NULL DEFAULT '1',"
	. "perpage int(10) NOT NULL DEFAULT '20',"
	. "viewfields varchar(255) NOT NULL DEFAULT '',"
	. "view tinyint(1) NOT NULL DEFAULT '1',"
	. "wide tinyint(1) NOT NULL DEFAULT '1',"
	. "INDEX (u_id)"
	. ")";

    COM_errorLog("Attempting to create table ct_user for contact plugin", 1);
    DB_query($createsql,1);

    if (DB_error()) {
        return false;
    }

    COM_errorLog('...success',1);

    $steps['createtable'] = 1;

    // Create the contact admin security group
    COM_errorLog("Attempting to create Contact admin group", 1);
    DB_query("INSERT INTO {$_TABLES['groups']} (grp_name, grp_descr) "
        . "VALUES ('Contact Admin', 'Users in this group can administer the Contact plugin')",1);
    if (DB_error()) {
        uninstall_contact($steps);
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    $steps['insertgroup'] = 1;

    // Save the grp id for later uninstall
    COM_errorLog('About to save group_id to vars table for use during uninstall',1);
    DB_query("INSERT INTO {$_TABLES['vars']} VALUES ('contact_group_id', LAST_INSERT_ID())",1);
    if (DB_error()) {
        uninstall_contact($steps);
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    $steps['savedgroupid'] = 1;

    $group_id = DB_getItem($_TABLES['vars'], 'value', "name = 'contact_group_id'");

    // Add contact features
    COM_errorLog('Attempting to add contact.view feature',1);
    DB_query("INSERT INTO {$_TABLES['features']} (ft_name, ft_descr) "
        . "VALUES ('contact.view','Access to View Contacts')",1);
    if (DB_error()) {
        uninstall_contact($steps);
        return false;
        exit;
    }
    $view_id = DB_insertId();
    COM_errorLog('...success',1);
    $steps['insertedfeatureview'] = 1;

    COM_errorLog('Attempting to add contact.edit feature',1);
    DB_query("INSERT INTO {$_TABLES['features']} (ft_name, ft_descr) "
        . "VALUES ('contact.edit','Access to Contact editor')",1);
    if (DB_error()) {
        uninstall_contact($steps);
        return false;
        exit;
    }
    $edit_id = DB_insertId();
    COM_errorLog('...success',1);
    $steps['insertedfeatureedit'] = 1;

    COM_errorLog('Attempting to add contact.delete feature',1);
    DB_query("INSERT INTO {$_TABLES['features']} (ft_name, ft_descr) "
        . "VALUES ('contact.delete','Ability to delete contacts')",1);
    if (DB_error()) {
        uninstall_contact($steps);
        return false;
        exit;
    }
    $delete_id = DB_insertId();
    COM_errorLog('...success',1);
    $steps['insertedfeaturedelete'] = 1;

    COM_errorLog('Attempting to add contact.admin feature',1);
    DB_query("INSERT INTO {$_TABLES['features']} (ft_name, ft_descr) "
        . "VALUES ('contact.admin','Ability to administer contacts')",1);
    if (DB_error()) {
        uninstall_contact($steps);
        return false;
        exit;
    }
    $admin_id = DB_insertId();
    COM_errorLog('...success',1);
    $steps['insertedfeatureadmin'] = 1;

    // Now add the features to the group
    COM_errorLog('Attempting to give Contact Admin group access to contact.view feature',1);
    DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($view_id, $group_id)");
    if (DB_error()) {
        uninstall_contact($steps);
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    $steps['addedviewtogroup'] = 1;

    COM_errorLog('Attempting to give Contact Admin group access to contact.edit feature',1);
    DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($edit_id, $group_id)");
    if (DB_error()) {
        uninstall_contact($steps);
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    $steps['addededittogroup'] = 1;

    COM_errorLog('Attempting to give Contact Admin group access to contact.delete feature',1);
    DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($delete_id, $group_id)",1);
    if (DB_error()) {
        uninstall_contact($steps);
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    $steps['addeddeletetogroup'] = 1;

    COM_errorLog('Attempting to give Contact Admin group access to contact.admin feature',1);
    DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($admin_id, $group_id)",1);
    if (DB_error()) {
        uninstall_contact($steps);
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    $steps['addedadmintogroup'] = 1;

    // OK, now give Root users access to this plugin now! NOTE: Root group should always be 1
    COM_errorLog('Attempting to give all users in Root group access contact admin group',1);
    DB_query("INSERT INTO {$_TABLES['group_assignments']} VALUES ($group_id, NULL, 1)");
    if (DB_error()) {
        uninstall_contact($steps);
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    $steps['addedrootuserstogroup'] = 1;

    // Register the plugin with Geeklog
    if (DB_count($_TABLES['plugins'],'pi_name','contact') > 0) {
        COM_errorLog('Attempting to remove contact rentry prior to adding an updated entry',1);
        DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'contact'");
        if (DB_error()) {
            uninstall_contact($steps);
            return false;
            exit;
        }
        COM_errorLog('...success',1);
    } else {
        // Only install data on a fresh installation
        // This plugin has no install data
    }

    COM_errorLog('Registering Contact plugin with Geeklog', 1);
    DB_delete($_TABLES['plugins'],'pi_name','contact');
    DB_query("INSERT INTO {$_TABLES['plugins']} (pi_name, pi_version, pi_gl_version, pi_homepage, pi_enabled) "
        . "VALUES ('contact', {$_CONTACT_CONF[version]}, '1.3.6', 'http://www.pigstye.net/geeklog.html', 1)");
    DB_query("INSERT INTO {$_TABLES['vars']} VALUES ('contact','1')");

    if (DB_error()) {
        uninstall_contact($steps);
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    COM_errorLog('Succesfully installed the Contact Plugin!',1);

    return true;
}

/**
* Removes the datastructures for this plugin from the Geeklog database
*
* This may get called by the install routine to undue anything done to this
* point.  To do that, $steps will have a list of steps to undo
*
* @steps   Array    Holds all the steps that have been completed by the install
*
*/  
function uninstall_contact($steps = '')
{
    global $_TABLES;

    // Uninstalls the contact plugin

    if (empty($steps) OR $steps['createtable'] == 1) {
        // Remove the contact table 
        COM_errorLog('Dropping contact table',1);
        DB_query("DROP TABLE ct_person",1);
        DB_query("DROP TABLE ct_company",1);
        DB_query("DROP TABLE ct_index",1);
        DB_query("DROP TABLE ct_user",1);
        
        COM_errorLog('...success',1);
    }

    // Remove security for this plugin

    // Remove the contact admin group
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = 'contact_group_id'");

    if (empty($steps) OR $steps['insertgroup'] == 1) {
        COM_errorLog('Attempting to remove the Contact Admin Group', 1);
        DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
        COM_errorLog('...success',1);
    }

    // Remove related features
    $view_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'contact.view'");
    $edit_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'contact.edit'");
    $delete_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'contact.delete'");
    $admin_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'contact.admin'");

    if (empty($steps) OR $steps['addedviewtogroup'] == 1) {
        // Remove access to those features 
        COM_errorLog('Attempting to remove rights to contact.view from all groups',1);
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $view_id",1);
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['addededittogroup'] == 1) {
        // Remove access to those features 
        COM_errorLog('Attempting to remove rights to contact.edit from all groups',1);
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $edit_id",1);
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['addeddeletetogroup'] == 1) {
        // Remove access to those features 
        COM_errorLog('Attempting to remove rights to contact.delete from all groups',1);
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $delete_id",1);
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['addedadmintogroup'] == 1) {
        // Remove access to those features 
        COM_errorLog('Attempting to remove rights to contact.admin from all groups',1);
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $admin_id",1);
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['addedrootuserstogroup'] == 1) {
        // Remove root users from the group
        COM_errorLog('Attempting to remove root users from admin of contacts');
        DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['insertedfeatureview'] == 1) {
        COM_errorLog('Attempting to remove the contact.edit feature',1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $view_id",1);
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['insertedfeatureedit'] == 1) {
        COM_errorLog('Attempting to remove the contact.edit feature',1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $edit_id",1);
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['insertedfeaturedelete'] == 1) {
        COM_errorLog('Attempting to remove the contact.delete feature',1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $delete_id",1);
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['insertedfeatureadmin'] == 1) {
        COM_errorLog('Attempting to remove the contact.admin feature',1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $admin_id",1);
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['savedgroupid']) {
        COM_errorLog('Attempting to remove the group id from the vars table',1);
        DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'contact_group_id'",1);
        COM_errorLog('success',1);
    }

    // Unregister the plugin with Geeklog
    if (empty($steps)) {
        COM_errorLog('Attempting to unregister the plugin from Geeklog',1);
        DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'contact'",1);
        DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'contact'");
        COM_errorLog('...success',1);

        COM_errorLog('leaving uninstall_contact',1);
        return true;
    } else {
        return false;
    }
}

/* 
* Main Function
*/

$display = COM_siteHeader();

If ($action == '') {
    $display .= COM_startBlock($LANG_CT02['install_header']);
    if (DB_count($_TABLES['vars'], 'name', 'contact') == 0) {
        $T = new Template($_CONF['path'] . 'plugins/contact/templates');
        $T->set_file('install', 'install.thtml');
		$T->set_var('install_header', $LANG_CT02['notinstalled']);
		$T->set_var('installmsg1', $LANG_CT02['notinstalled_msg']);
		$T->set_var('img',$_CONF['site_url'] . '/contact/images/contact.gif');
		$T->set_var('cgiurl', $_CONF['site_url'] . '/admin/plugins/contact/install.php');
		$T->set_var('btnmsg', $LANG_CT02['install']);
		$T->set_var('action','install');
		$T->parse('output','install');
        $display .= $T->finish($T->get_var('output'));
    } else {
        $T = new Template($_CONF['path'] . 'plugins/contact/templates');
        $T->set_file('install', 'install.thtml');
		$T->set_var('install_header', $LANG_CT02['installed']);
		$T->set_var('installmsg1', $LANG_CT02['installed_msg']);
		$T->set_var('installmsg2', $LANG_CT02['installed_msg2']);
		$T->set_var('img',$_CONF['site_url'] . '/contact/images/contact.gif');
		$T->set_var('cgiurl', $_CONF['site_url'] . '/admin/plugins/contact/install.php');
		$T->set_var('btnmsg', $LANG_CT02['uninstall']);
		$T->set_var('action','uninstall');
		$T->parse('output','install');
        $display .= $T->finish($T->get_var('output'));
    }
    $display .= COM_endBlock();
} elseif ($action == 'install') {
    // Install this plugin
    if (plugin_install_contact()) {
        $display .= COM_startBlock($LANG_CT02['installation_complete']);
        $display .= $LANG_CT02['installation_complete_msg'];
        $display .= COM_endBlock();
    } else {
        // Error occured
        $display .= COM_startBlock($LANG_CT02['installation_failed']);
        $display .= $LANG_CT02['installation_failed_msg'];
        $display .= COM_endBlock();
    }   
} else {
    // Uninstall plugin
    if (uninstall_contact()) {
        // Uninstall worked
        $display .= COM_startBlock($LANG_CT02['uninstall_complete']);
        $display .= $LANG_CT02['uninstall_complete_msg'];
		$display .= "<p>" . $LANG_CT02['uninstall_complete_msg2'];
        $display .= COM_endBlock();
    } else {
        // Uninstall failed
        $display .= COM_startBlock($LANG_CT02['uninstall_failed']);
        $display .= $LANG_CT02['uninstall_failed_msg'];
        $display .= COM_endBlock();
    }
}

$display .= COM_siteFooter(true);

echo $display;

?>