<?php

// +---------------------------------------------------------------------------+
// | Contact Geeklog Plugin 1.0                                                |
// +---------------------------------------------------------------------------+
// | reindex.php                                                               |
// | database maintenance                                                      |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Author: Tom Willett       - tomw@pigstye.net                              |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');


/**
* Main 
*/

// Only let admin users access this page
if (!SEC_hasRights('contact.admin')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Contact reindex page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_CT02['access_denied']);
    $display .= $LANG_CT02['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

/**
* Insert/Update relation
*
*/
function setRelation($cid, $pid, $table) {
	$RESULT=DB_query("SELECT * FROM $table where p_id = $pid and c_id = $cid");
	$numrows = DB_numRows($RESULT);
	if ($numrows < 1) {
		DB_query("INSERT INTO $table set p_id = $pid, c_id = $cid");
	}
	$RESULT = DB_query("SELECT p_id from ct_company where (c_id = $cid) AND (p_id = 1)");
	$numrows = DB_numRows($RESULT);
	if ($numrows > 0) {
		DB_query("UPDATE ct_company SET p_id = $pid where (c_id = $cid) AND (p_id = 1)");
	}
}


print COM_siteHeader('none');

// First check companies without a person add dummy person for all companies or update company
$REC = DB_query("SELECT c_id from ct_company where p_id=1");
$numrows = DB_numRows($REC);
print "Adding dummy people or updating company for $numrows companies set to 1.<p>";
for ($i = 0; $i < $numrows; $i++) {
	$A = DB_fetchArray($REC);
	$REC1 = DB_query("SELECT c_id FROM ct_person WHERE co_id='" . $A['c_id'] . "'");
	if (DB_numRows($REC1) > 0) {
		$A1 = DB_fetchArray($REC1);
		$id = $A1['c_id'];
	} else {
		DB_query("INSERT INTO ct_person set fname='', lname='', co_id='" . $A['c_id'] . "',owner_id='" . $_USER['uid'] . "'");
		$id = DB_insertID();
	}
	DB_query("UPDATE ct_company set p_id = '{$id}' where c_id='" . $A['c_id'] . "'");
	setRelation($A['c_id'], $id, 'ct_index');
}

// Check each company make sure it has a person and it is linked up correctly
$REC = DB_query("SELECT c_id, p_id from ct_company");
$numrows = DB_numRows($REC);
print "Found $numrows companies, checking to see if they have a person pointing to them -- Fixing them";
for ($i=0; $i<$numrows; $i++) {
	$A = DB_fetchArray($REC);
	$REC1 = DB_query("SELECT c_id from ct_person where co_id='" . $A['c_id'] . "'");
	if (DB_numRows($REC1) > 0) {
		$REC1 = DB_query("SELECT c_id from ct_person where co_id='1' and c_id='" . $A['p_id'] . "'");
		if (DB_numRows($REC1) > 0) {
			DB_query("Update ct_person set co_id = '" . $A['c_id'] . "' where c_id = '" . $A['p_id'] . "'");
		}
	} else {
		DB_query("INSERT INTO ct_person set fname='', lname='', co_id='" . $A['c_id'] . "',owner_id='" . $_USER['uid'] . "'");
	}
}

// See if any contact company pairs need to be in index
DB_query("DELETE FROM ct_index");
$REC = DB_query("SELECT c_id as pid, co_id as cid from ct_person");
$numrows = DB_numRows($REC);
print "<p>Checking $numrows entries in index for people not in index.<p>";
for ($i = 0; $i < $numrows; $i++) {
	$A = DB_fetchArray($REC);
	setRelation($A['cid'], $A['pid'], 'ct_index');
}

$REC = DB_query("SELECT c_id as cid, p_id as pid from ct_company");
$numrows = DB_numRows($REC);
print "<p>Checking $numrows entries in index for companies not in index.<p>";

for ($i = 0; $i < $numrows; $i++) {
	$A = DB_fetchArray($REC);
	setRelation($A['cid'], $A['pid'], 'ct_index');
}


// Now remove remove any pointing to deleted records if any
$REC = DB_query("select ct_index.p_id from ct_index left join ct_person on ct_index.p_id = ct_person.c_id where ct_index.p_id is null");
$numrows = DB_numRows($REC);
print "<p>Removing $numrows entries from index for deleted people.<p>";
for ($i=0; $i<$numrows; $i++) {
	$A = DB_fetchArray($REC);
	DB_query("DELETE FROM ct_index where p_id='" . $A['p_id'] . "'");
}
$REC = DB_query("select ct_index.c_id from ct_index left join ct_company on ct_index.c_id = ct_company.c_id where ct_index.c_id is null");
$numrows = DB_numRows($REC);
print "<p>Removing $numrows entries from index for deleted companies.<p>";
for ($i=0; $i<$numrows; $i++) {
	$A = DB_fetchArray($REC);
	DB_query("DELETE FROM ct_index where p_id='" . $A['p_id'] . "'");
}

// Now remove duplicates
$REC = DB_query("select c_id, p_id from ct_index group by c_id, p_id having ((count(c_id)>1) AND (count(p_id)>1))");
$numrows = DB_numRows($REC);
print "<p>Removing $numrows duplicate entries from index.<p>";
for ($i=0; $i<$numrows; $i++) {
	$A = DB_fetchArray($REC);
	DB_query("DELETE FROM ct_index where (p_id='" . $A['p_id'] . "') AND (c_id='" . $A['c_id'] . "')");
}

print "Finished!.<p><center><a href='" . $_CONF['site_admin_url'] . "/plugins/contact/index.php'>Press Here</a> to return to Contact Admin Page.</center><p>";

print COM_siteFooter(false); 
COM_errorLog("Contact Database reindexed.",1);
?>