<?php
//
// +---------------------------------------------------------------------------+
// | Contact Plugin 1.0 for Geeklog - The Ultimate Weblog                      |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API method and 2) implements all the common code needed by the Contact    |
// | PHP files.                                                                |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett       - tomw*pigstye.net                             |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

$langfile = $_CONF['path'] . 'plugins/contact/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile)) 
{
    require_once ($langfile);
}
else 
{
    require_once ($_CONF['path'] . 'plugins/contact/language/english.php');
}

require_once($_CONF['path'] . 'plugins/contact/config.php');
require_once($_CONF['path'] . 'plugins/contact/options.php');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Geeklog is asking us to provide any new items that show up in the type drop-down
* on search.php.  Let's let users search contacts
*
*/
function plugin_searchtypes_contact() 
{
    global $LANG_CT00, $LANG_CT01, $_CONTACT_CONF;

    if ($_CONTACT_CONF['search'] == '1') {
        $tmp['company'] = $LANG_CT00['contact'] . ' ' . $LANG_CT00['company'];
        $tmp['fname'] = $LANG_CT00['contact'] . ' ' . $LANG_CT01['fname'];
        $tmp['lname'] = $LANG_CT00['contact'] . ' ' . $LANG_CT01['lname'];
        $tmp['city'] = $LANG_CT00['contact'] . ' ' . $LANG_CT01['city'];
        $tmp['state'] = $LANG_CT00['contact'] . ' ' . $LANG_CT01['state'];
    } else {
        $tmp=array();
    }
    return $tmp;
}


/**
* this searches for pages matching the user query and returns an array 
* for the header and table rows back to search.php where it will be formated and
* printed 
*
* @query            string          Keywords user is looking for
* @datestart        date/time       Start date to get results for
* @dateend          date/time       End date to get results for
* @topic            string          The topic they were searching in
* @type             string          Type of items they are searching
* @author           string          Get all results by this author
*
*/
function plugin_dopluginsearch_contact($query, $datestart, $dateend, $topic, $type, $author) 
{
	global $_TABLES, $_CONF, $LANG_CT00, $LANG_CT01, $LANG01, $_CONTACT_CONF;

    if (empty($type)) {
        $type = 'all';
    }

    // OK, now create new plugin object
    $plugin_results = new Plugin();
    $plugin_results->plugin_name = 'contact';
    $plugin_results->searchlabel = $LANG_CT00['contacts'] . ' ' . $LANG01[6];

    // Bail if we aren't supppose to do our search
    if ($_CONTACT_CONF['search'] == '0') {
        return $plugin_results;
    }
    
    if ($type <> 'all' AND $type <> 'company' AND $type <> 'fname' AND $type <> 'lname' AND $type <> 'city' AND $type <> 'state') {
        return $plugin_results;
    }

    // Insert table header labels
    require_once($_CONF['path_system'] . 'classes/plugin.class.php');
    $plugin_results->addSearchHeading($LANG_CT01['name']);
    $plugin_results->addSearchHeading($LANG_CT01['city']);
    $plugin_results->addSearchHeading($LANG_CT01['state']);

    // Build search SQL
    $sql = "SELECT * from ct_person ";
    if ($type == 'fname') {
        $sql .= "WHERE fname like '{$query}'";
    } else if ($type == 'lname') {
        $sql .= "WHERE lname like '{$query}'";
    } else if ($type == 'city') {
        $sql .= "WHERE city like '{$query}'";
    } else if ($type == 'state') {
        $sql .= "WHERE state like '{$query}'";
    } else {
        $sql .= "WHERE fname like '{$query}' OR lname like '{$query}' OR city like '{$query}' OR state like '{$query}'";
    }
    
    $result = DB_query($sql);
    $mycount = DB_numRows($result);

	for ($i = 1; $i <= $mycount; $i++) {
        $A = DB_fetchArray($result);

        if(SEC_hasAccess($A[owner_id],$A[group_id],$A[perm_owner],$A[perm_group],$A[perm_members],$A[perm_anon])){
            $rcnt++;
            $row = array('<a href="' . $_CONF['site_url'] . '/contact/viewp.php?c_id=' 
                 . $A['c_id'] . '">' . $A['fname'] . ' ' . $A['lname'] . '</a>',
                 $A['city'], $A['state']);
            $plugin_results->addSearchResult($row);
        }
	
	}

    $sql = "SELECT * from ct_company ";
    if ($type == 'company') {
        $sql .= "WHERE name like '{$query}'";
    } else if ($type == 'city') {
        $sql .= "WHERE city like '{$query}'";
    } else if ($type == 'state') {
        $sql .= "WHERE state like '{$query}'";
    } else {
        $sql .= "WHERE name like '{$query}' OR city like '{$query}' OR state like '{$query}'";
    }
    
    $result = DB_query($sql);
    $mycount = DB_numRows($result);

	for ($i = 1; $i <= $mycount; $i++) {
        $A = DB_fetchArray($result);

        if(SEC_hasAccess($A[owner_id],$A[group_id],$A[perm_owner],$A[perm_group],$A[perm_members],$A[perm_anon])){
            $rcnt++;
            $row = array('<a href="' . $_CONF['site_url'] . '/contact/viewc.php?c_id=' 
                 . $A['c_id'] . '">' . $A['name'] . '</a>',
                 $A['city'], $A['state']);
            $plugin_results->addSearchResult($row);
        }
	
	}

    $plugin_results->num_searchresults = $rcnt;
    $plugin_results->num_itemssearched = DB_count($_TABLES['external']);

    return $plugin_results;
}

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
*/
function plugin_getmenuitems_contact()
{
    global $_CONF, $_CONTACT_CONF;

    $menuitems = array();
	if ((!empty($_CONTACT_CONF['menu'])) && ((SEC_hasRights('contact.view')) || ($_CONTACT_CONF['contact_anon'] == 1))) {
    	$menuitems[$_CONTACT_CONF['menu']] = $_CONF['site_url'] . "/contact/index.php";
    }
    return $menuitems;
}

/**
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
*/
function plugin_commentsupport_contact() 
{
    // Static Pages will not use comments
    return false;
}

/**
* Shows the statistics for the contacts plugin on stats.php.  If
* $showsitestats is 1 then we are to only print the overall stats in the 'site
* statistics' box otherwise we show the detailed stats for the contacts
*
* @showsitestate        int         Flag to let us know which stats to get
*/
function plugin_showstats_contact($showsitestats) 
{
	global $_TABLES, $LANG_CT00;
	
    if ($showsitestats == 1) {
        $total_contacts=DB_count('ct_person');
        $total_hits = DB_getItem($_TABLES['vars'],'value','name="contact"');
        $retval = "<table border = '0' width='100%' cellspacing='0' cellpadding='0'>";
        $retval .= "<tr><td>" . $LANG_CT00['stats'] . "</td>";
        $retval .= "<td align='right'>" . $total_contacts . " (" . $total_hits . ")&nbsp;&nbsp </td></tr></table>";
    	                                
    } else {
	    $retval = '';
	}
	return $retval;
}

/**
* This will put an option for contact in the command and control block on
* moderation.php
*
*/
function plugin_cclabel_contact() 
{
    global $LANG_CT00, $_CONF;

    return array($LANG_CT00['contacts'],$_CONF['site_admin_url'] . '/plugins/contact/index.php',$_CONF['site_url'] . '/contact/images/contact.gif');
}

/**
* returns the administrative option for this plugin
*
*/
function plugin_getadminoption_contact() 
{
    global $_CONF, $LANG_CT00;

    if (SEC_hasRights('contact.admin')) {
        return array($LANG_CT00['contacts'], $_CONF['site_admin_url'] . '/plugins/contact/index.php', DB_count('ct_person') - 1);
    }
}

/**
* returns the user option for this plugin
*
*/
function plugin_getuseroption_contact() 
{
    global $_CONF, $LANG_CT00;

    if (SEC_hasRights('contact.edit,contact.delete,contact.view','OR')) {
        return array($LANG_CT00['contacts'], $_CONF['site_url'] . '/contact/index.php', 0);
    }
}

// +---------------------------------------------------------------------------+
// | Contact Plugin Functions                                                  |
// +---------------------------------------------------------------------------+

/**
* Returns the Person Fields Array
* Gets the fields array and merges with the vars array
* @return array	 Array of field names for person table.
*/
function CT_getPFields() {
	global $LANG_CT01, $_CONTACT_CONF;
	$retval = $LANG_CT01;
	$retval['phone1'] = $_CONTACT_CONF['contact_phone1'];
	$retval['phone2'] = $_CONTACT_CONF['contact_phone2'];
	$retval['email1'] = $_CONTACT_CONF['contact_email1'];
	$retval['email2'] = $_CONTACT_CONF['contact_email2'];
	$retval['url1'] = $_CONTACT_CONF['contact_url1'];
	$retval['url2'] = $_CONTACT_CONF['contact_url2'];
	$retval['date1'] = $_CONTACT_CONF['contact_date1'];
	$retval['date2'] = $_CONTACT_CONF['contact_date2'];
	$retval['user1'] = $_CONTACT_CONF['contact_user1'];
	$retval['user2'] = $_CONTACT_CONF['contact_user2'];
	return $retval;
}

/**
* Returns the Company Fields Array
* Gets the fields array and merges it with the vars array.
* @return	array	Array of field names for company table
*/

function CT_getCFields() {
	global $LANG_CT01, $_CONTACT_CONF;
	$retval = $LANG_CT01;
	$retval['phone1'] = $_CONTACT_CONF['contactc_phone1'];
	$retval['phone2'] = $_CONTACT_CONF['contactc_phone2'];
	$retval['email1'] = $_CONTACT_CONF['contactc_email1'];
	$retval['email2'] = $_CONTACT_CONF['contactc_email2'];
	$retval['url1'] = $_CONTACT_CONF['contactc_url1'];
	$retval['url2'] = $_CONTACT_CONF['contactc_url2'];
	$retval['date1'] = $_CONTACT_CONF['contactc_date1'];
	$retval['date2'] = $_CONTACT_CONF['contactc_date2'];
	$retval['user1'] = $_CONTACT_CONF['contactc_user1'];
	$retval['user2'] = $_CONTACT_CONF['contactc_user2'];
	return $retval;
}

/* 
* Add hit to table for c_id
*
*/
function CT_contactHit($cid,$table) {
	global $_TABLES;
	
	DB_query("UPDATE $table SET hits = hits +1 WHERE c_id = $cid");
	DB_query("UPDATE " . $_TABLES['vars'] . " SET value = value + 1 WHERE name = 'contact'");
}

/* 
* Add general hit to contacts
*
*/
function CT_contactAddHit() {
	global $_TABLES;
	
	DB_query("UPDATE " . $_TABLES['vars'] . " SET value = value + 1 WHERE name = 'contact'");
}

/**
* Return SQL where statement with appropriate permissions
*
* Takes User id and permission and returns SQL where clause which will return the appropriate objects.
* This assumes that the table has the following security structure:
* owner_id        | mediumint(8)          
* group_id        | mediumint(8)          
* perm_owner      | tinyint(1) unsigned   
* perm_group      | tinyint(1) unsigned   
* perm_members    | tinyint(1) unsigned  
* perm_anon       | tinyint(1) unsigned  
* This will work with the standard GL tables
*
* @table	str	Table name (used in joins)
* @access	int	Access if blank read access  2 = read 3 = read/edit
* @u_id int     User ID if blank current user
*
* @return string	Where clause of sql statement
*
*/

function CT_getPerms($table='',$access='2',$u_id='') {
	global $_USER, $_GROUPS;
	
	if ($table != '') { $table .= '.'; }
	if ($u_id == '') {
		$uid = $_USER['uid'];
		$GROUPS = $_GROUPS;
	} else {
		$uid = $u_id;
		$GROUPS = SEC_getUserGroups($uid);
	}
	$where = "((" . $table . "perm_anon >= $access)";
	// check to see if anonymous user
	if ($uid > 1) {
		$where .= " OR (" . $table . "perm_members >= $access)";
		foreach ($GROUPS as $group) {
			$where .= " OR ((" . $table . "group_id = $group) AND (" . $table . "perm_group >= $access))";
		}
		$where .= " OR ((" . $table . "owner_id = $uid) AND (" . $table . "perm_owner >= $access))";
	}
	return $where . ")"; 
}



/**
* Removes the datastructures for this plugin from the Geeklog database
*
* This may get called by the install routine to undue anything done to this
* point.  To do that, $steps will have a list of steps to undo
*
*/  
function plugin_uninstall_contact()
{
    global $_TABLES;

    // Uninstalls the contact plugin

    // Remove the contact table 
    COM_errorLog('Dropping contact table',1);
    DB_query("DROP TABLE ct_person",1);
    DB_query("DROP TABLE ct_company",1);
    DB_query("DROP TABLE ct_index",1);
    DB_query("DROP TABLE ct_user",1);

    // Remove security for this plugin

    // Remove the contact admin group
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = 'contact_group_id'");

    COM_errorLog('Attempting to remove the Contact Admin Group', 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);

    // Remove related features
    $view_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'contact.view'");
    $edit_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'contact.edit'");
    $delete_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'contact.delete'");
    $admin_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'contact.admin'");

    // Remove access to those features 
    COM_errorLog('Attempting to remove rights to contact.view from all groups',1);
    DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $view_id",1);

    // Remove access to those features 
    COM_errorLog('Attempting to remove rights to contact.edit from all groups',1);
    DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $edit_id",1);

    // Remove access to those features 
    COM_errorLog('Attempting to remove rights to contact.delete from all groups',1);
    DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $delete_id",1);

    // Remove access to those features 
    COM_errorLog('Attempting to remove rights to contact.admin from all groups',1);
    DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $admin_id",1);

    // Remove root users from the group
    COM_errorLog('Attempting to remove root users from admin of contacts');
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);

    COM_errorLog('Attempting to remove the contact.edit feature',1);
    DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $view_id",1);

    COM_errorLog('Attempting to remove the contact.edit feature',1);
    DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $edit_id",1);

    COM_errorLog('Attempting to remove the contact.delete feature',1);
    DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $delete_id",1);

    COM_errorLog('Attempting to remove the contact.admin feature',1);
    DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $admin_id",1);

    COM_errorLog('Attempting to remove the group id from the vars table',1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'contact_group_id'",1);

    // Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'contact'",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'contact'");

    COM_errorLog('leaving plugin_uninstall_contact',1);
    return true;
}
?>