<?php

###############################################################################
# lang.php
# This is the English language page for the Geeklog Contact Plug-in!
#
# Copyright (C) 2002 Tom Willett
# tomw@pigstye.net
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
###############################################################################

###############################################################################
# Array Format: 
# $LANGXX[YY]:	$LANG - variable name
#		  	XX - file id number
#			YY - phrase id number
###############################################################################

/**
* General language
*/

$LANG_CT00 = array (
	'stats'		=> 'Contacts (views)',
	'save' 		=> 'Save',
	'cancel' 		=> 'Cancel',
	'people' 		=> 'People',
	'person'		=> 'Person',
	'companies' 	=> 'Companies',
	'company'		=> 'Company',
	'contact' 	=> 'Contact',
	'contacts' 	=> 'Contacts',
	'bademail'	=> 'Bad Email Format'
);

/**
* Database Field name defaults
*/

$LANG_CT01 = array (
	'salutation' 	=> 'Salutation',
	'fname' 		=> 'First Name',
	'mname' 		=> 'Middle Name',
	'lname' 		=> 'Last Name',
	'name' 		=> 'Name',
	'title' 		=> 'Title',
	'address1' 	=> 'Address1',
	'address2' 	=> 'Address2',
	'city' 		=> 'City',
	'state' 		=> 'State',
	'postalcode' 	=> 'Postal Code',
	'country' 	=> 'Country',
	'phone1' 		=> 'Phone1',
	'phone2' 		=> 'Phone2',
	'fax' 		=> 'Fax',
	'email1' 		=> 'Email1',
	'email2' 		=> 'Email2',
	'url1' 		=> 'URL1',
	'url2' 		=> 'URL2',
	'date1' 		=> 'Date1',
	'date2' 		=> 'Date2',
	'user1' 		=> 'User1',
	'user2' 		=> 'User2',
	'notes'		=> 'Notes'
);

/**
* Install Screen Language
*/
$LANG_CT02 = array (
	'phone1' 		=> 'Home Phone',
    'phone2' 		=> 'Work Phone',
	'email1' 		=> 'Home Email',
	'email2' 		=> 'Work Email',
	'url1' 		=> 'Personal URL',
	'url2' 		=> 'Work URL',
	'date1' 		=> 'Birth Date',
	'date2' 		=> 'Anniv Date',
	'user1' 		=> 'UserDef 1',
	'user2' 		=> 'UserDef 2',
	'cphone1' 	=> 'Main Phone',
    'cphone2' 	=> 'Cell Phone',
	'cemail1' 	=> 'Main Email',
	'cemail2' 	=> 'Sec Email',
	'curl1' 		=> 'Business URL',
	'curl2' 		=> 'Personal URL',
	'cdate1' 		=> 'Start Date',
	'cdate2' 		=> 'End Date',
	'cuser1' 		=> 'UserDef 1',
	'cuser2' 		=> 'UserDef 2',
  	'access_denied' => 'Access Denied',
   	'access_denied_msg' => 'You are illegally trying access one of the Contact administration pages.  Please note that all attempts to illegally access this page are logged',
	'install_header' => 'Install Contact Plug-in',
   	'installation_complete' => 'Installation Complete',
   	'installation_complete_msg' => 'The data structures for the Contact plug-in for Geeklog have been successfully installed into your database!  If you ever need to uninstall this plug-in, please read the README document that came with this plug-in.',
   	'installation_failed' => 'Installation Failed',
   	'installation_failed_msg' => 'The installation of the Contact plug-in failed.  Please see your Geeklog error.log file for diagnostic information',
   	'uninstall_complete' => 'Uninstall Complete',
   	'uninstall_complete_msg' => 'The data structures for the Contacts plug-in have been successfully removed from your Geeklog database.',
    'uninstall_complete_msg2' => 'See the README for complete uninstall instructions.',
   	'uninstall_failed' => 'Uninstall Failed',
   	'uninstall_failed_msg' => 'The uninstall of the Contacts plug-in failed.  Please see your Geeklog error.log file for diagnostic information',
	'notinstalled' => 'Contact Plug-in is not installed.',
	'notinstalled_msg' => 'Press button to install Contact Plug-in.',
	'install' 	=> 'Install',
	'uninstall' 	=> 'UnInstall',
	'installed' 	=> 'Contact Plug-in is installed.',
	'installed_msg' => 'Press button to uninstall Contact Plug-in.',
	'installed_msg2' => '<< Caution >>This will delete all your Contact Plug-in data.'
);

/**
* Admin Screen Language
*/

$LANG_CT03 = array (
	'reindex'		=> 'Re-index Contact Database',
	'anon_msg'		=> 'Allow Anonymous Users to View Contacts?',
	'addedit'		=> 'Add Contact',
	'admin_home'	=> 'Admin Home',
	'uninstall' 	=> 'Uninstall',
	'admin_header' => 'Contact Plug-in Options',
   	'admin_msg1' 	=> 'Both the Person and Company contact forms have 10 user definable fields.',
	'admin_msg2' 	=> 'You can change the labels for these fields here.  Please note that the phone fields expect phone numbers, the date fields, dates, etc.  They are not free form fields.'
);

/**
* User Screen Language
*/

$LANG_CT04 = array (
	'wide'		=> 'Wide View',
	'edit_msg'	=> 'Add Contact',
	'view_msg'	=> 'View Contacts',
	'header' 	=> 'Contact Plug-in User Preferences',
	'perpage' => 'Contacts per Page ',
	'compact' => 'Compact',
	'full' 	=> 'Full',
	'c_head'	=> 'Display Columns'
);

/**
* Edit Contact Language
*/

$LANG_CT05 = array (
	'edit_contact'	=> 'Edit Contact',
	'save'			=> 'Save',
	'cancel'		=> 'Cancel',
	'add_person'	=> 'Add Person',
	'add_company'	=> 'Add Company',
	'delete'		=> 'Delete',
	'view'			=> 'View Contacts'
);

/**
* Index Language
*/

$LANG_CT06 = array (
	'created'	=> 'Created',
	'views'		=> 'Views',
	'deleter'	=> 'Remove Relationship',
	'mcompany'	=> 'Main Company',
	'ocompany'	=> 'Other Company',
	'mperson'	=> 'Main Person',
	'operson'	=> 'Other Person',
	'options'	=> 'Options',
	'edit'		=> 'Edit',
	'view'		=> 'View',
	'add_contact' => 'Add Contact',
	'edit_contact' => 'Edit Contact'
);



?>