<?php
//
// +---------------------------------------------------------------------------+
// | Contact Geeklog Plugin 1.1                                                |
// +---------------------------------------------------------------------------+
// | edit.php                                                                  |
// | Contact Edit   page.                                                      |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Author: Tom Willett       - tomw@pigstye.net                              |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Only let users with edit rights access this page
if (!SEC_hasRights('contact.edit')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Contact Edit page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
	print COM_refresh($_CONF['site_url'] . '/index.php');
    exit;
}

/**
* Insert/Update relation
*
*/
function setRelation($cid, $pid, $table) {
	$RESULT=DB_query("SELECT * FROM $table where p_id = $pid and c_id = $cid");
	$numrows = DB_numRows($RESULT);
	if ($numrows < 1) {
		DB_query("INSERT INTO $table set p_id = $pid, c_id = $cid");
	}
	$RESULT = DB_query("SELECT p_id from ct_company where (c_id = $cid) AND (p_id = 1)");
	$numrows = DB_numRows($RESULT);
	if ($numrows > 0) {
		DB_query("UPDATE ct_company SET p_id = $pid where (c_id = $cid) AND (p_id = 1)");
	}
}

/**
*
* Formats a telephone number
*
* Takes an input string and formats it according to the format 1 (999) 123-4567 #891 or 123 (999) 123-4567 #89
* It recognizes extensions preceded by #. ('ext' is replaced by '#').
* @str	string	Input string
* @return	string	Formated String
*
*/
function formatPhone($pstr) {
	$nstr = strip_tags($pstr);
	$nstr = preg_replace("/ext/i","#",$nstr);
	list($nstr, $ext) = preg_split('/#/',$nstr);
	$nstr = preg_replace("/\D/","",$nstr);
	$slen = strlen($nstr);
	switch ($slen) {
		case 7:
			$ret=substr($nstr,0,3) . '-' . substr($nstr,3);
			break;
		case 10:
			$ret='(' . substr($nstr,0,3) . ') ' . substr($nstr,3,3) . '-' . substr($nstr,6);
			break;
		case 11:
			$ret = substr($nstr,0,1) . ' (' . substr($nstr,1,3) . ') ' . substr($nstr,4,3) . '-' . substr($nstr,7);
			break;
		case 13:
			$ret = substr($nstr,0,3) . " (" . substr($nstr,3,3) . ") " . substr($nstr,6,3) . "-" . substr($nstr,9);
			break;
		default:
			$ret=$pstr;
	}
	if (strlen($ext)>0) {
		$ret=$ret . " #" . $ext;
	}
	return addslashes($ret);
}

/**
*
* Clean up input strip html and php tags and double quotes, back quotes and control characters
*
* @str	string	Input string to clean up
* @return	string	Clean String
*
*/
function cleanStr($str) {
	$ret = preg_replace("/[\001-\037\042\140\177]/","",$str);
	$ret = strip_tags($ret);
	return addslashes($ret);
}

/** 
*
* This function checks to see if an email address is in the correct form
*
* @email        string      Email address to verify
* @return 	string	Email address if valid -- error message if not
*
*/
function chkEmail($email) { 
	global $LANG_CT00;
	
	if (eregi("^[0-9a-z]([-_.]?[0-9a-z])*@[0-9a-z]([-.]?[0-9a-z])*\\.[a-wyz][a-z](g|l|m|pa|t|u|v)?$", $email)) { 
    	$ret = $email; 
    } else {
    	$ret = cleanStr($email);
    }
    return addslashes($ret);
} 

/**
*
* Checks to see if URL is correct format -- filters out control and illegal characters
*
* @url	string	URL to verify
* @return string	URL Corrected
*
*/

function chkURL($url) {
	$ret = preg_replace("/[\001-\040\034\054\074\076\133\134\135\136\140\173\175\176\177]/","",$url);
	if ((!preg_match("/:\/\//",$ret)) && (!empty($url))) {
		$ret = "http://" . $ret;
	}
	return addslashes($ret);
}

/**
*
* Converts text date to yyyy-mm-dd format for mysql
*
*/
function fixDate($date) {
	if ($date == '') {
		return '';
	} else {
		return date("Y-m-d",strtotime($date));
	}
	
}
     


/**
* Main 
*/

$display = COM_siteHeader();

if ($action == $LANG_CT05['add_person']) {
	$c_type = 1;
	$c_id='';
} elseif ($action == $LANG_CT05['add_company']) {
	$c_type = 2;
	$c_id='';
} elseif ($action == $LANG_CT05['save']) {
	// convert perms
	list($perm_owner,$perm_group,$perm_members,$perm_anon) = SEC_getPermissionValues($perm_owner,$perm_group,$perm_members,$perm_anon);
	// Clean up input
	$salutation = cleanStr($salutation);
	$fname = cleanStr($fname);
	$mname = cleanStr($mname);
	$lname = cleanStr($lname);
	$name = cleanStr($name);
	$title = cleanStr($title);
	$address1 = cleanStr($address1);
	$address2 = cleanStr($address2);
	$city = cleanStr($city);
	$state = cleanStr($state);
	$postalcode = cleanStr($postalcode);
	$country = cleanStr($country);
	$phone1=formatPhone($phone1);
	$phone2=formatPhone($phone2);
	$fax=formatPhone($fax);
	$email1 = chkEmail($email1);
	$email2 = chkEmail($email2);
	$url1 = chkURL($url1);
	$url2 = chkURL($url2);
	$date1 = fixDate($date1);
	$date2 = fixDate($date2);
	$user1 = cleanStr($user1);
	$user2 = cleanStr($user2);
	$notes = addslashes(COM_checkHTML(COM_killJS(COM_checkWords($notes))));
	if ((isset($c_id)) && ($c_id != '')) {
		if ($c_type == 1) {
			DB_query("UPDATE ct_person set co_id='{$companyID}', salutation='{$salutation}', " .
				"fname='{$fname}', mname='{$mname}', lname='{$lname}', title='{$title}', " .
				"address1='{$address1}', address2='{$address2}', city='{$city}', " .
				"state='{$state}', postalcode='{$postalcode}', country='{$country}', " .
				"phone1='{$phone1}', phone2='{$phone2}', fax='{$fax}', " .
				"email1='{$email1}', email2='{$email2}', url1='{$url1}', url2='{$url2}', cdate=" . time() . "," .
				"owner_id='$owner_id', group_id='$group_id', perm_owner='$perm_owner'," .
				"perm_group='$perm_group', perm_members='$perm_members', perm_anon='$perm_anon', " .
				"date1=IF('$date1'='',NULL,'$date1'), date2=IF('$date2'='',NULL,'{$date2}'), user1='{$user1}', user2='{$user2}', notes='{$notes}' where c_id=$c_id");
			setRelation($companyID,$c_id,"ct_index");
		} else {
			if ($personID == 1) {
				DB_query("INSERT into ct_person set co_id={$c_id}, fname='', lname=''");
				$personID=DB_insertID();
			}
			$R = DB_query("SELECT c_id from ct_person where ((co_id=$c_id) AND (fname='') AND (lname=''))");
			if (DB_numRows($R) > 0) {
				DB_query("DELETE FROM ct_person where c_id='" . $R['c_id'] . "'");
			}
			$R = DB_query("SELECT c_id from ct_person where (c_id=$personID) AND (co_id=1)");
			$nr = DB_numRows($R);
			for ($i=0; $i<$nr ; $i++) {
				$A = DB_fetchArray($R);
				DB_query("UPDATE ct_person set co_id={$c_id} where c_id='" . $A['c_id'] . "'");
			}	
			DB_query("UPDATE ct_company set p_id='{$personID}', name='{$name}', " .
				"address1='{$address1}', address2='{$address2}', city='{$city}', " .
				"state='{$state}', postalcode='{$postalcode}', country='{$country}', " .
				"phone1='{$phone1}', phone2='{$phone2}', fax='{$fax}', " .
				"email1='{$email1}', email2='{$email2}', url1='{$url1}', url2='{$url2}', cdate=" . time() . "," .
				"owner_id='$owner_id', group_id='$group_id', perm_owner='$perm_owner'," .
				"perm_group='$perm_group', perm_members='$perm_members', perm_anon='$perm_anon', " .
				"date1=IF('$date1'='',NULL,'{$date1}'), date2=IF('$date2'='',NULL,'{$date2}'), user1='{$user1}', user2='{$user2}', notes='{$notes}' where c_id=$c_id");
			setRelation($c_id, $personID, "ct_index");
		}			 
	} else {
		if ($c_type == 1) {
			DB_query("INSERT INTO ct_person SET co_id='{$companyID}', salutation='$salutation', cdate=" . time() . "," .
				"fname='$fname', mname='$mname', lname='$lname', title='$title', " .
				"address1='$address1', address2='$address2', city='$city', state='$state', " .
				"postalcode='$postalcode', country='$country', phone1='$phone1', phone2='$phone2', " .
				"fax='$fax', email1='$email1', email2='$email2', " .
				"url1='$url1', url2='$url2', date1=IF('$date1'='',NULL,'$date1'), date2=IF('$date2'='',NULL,'$date2'), user1='$user1', " .
				"owner_id='$owner_id', group_id='$group_id', perm_owner='$perm_owner'," .
				"perm_group='$perm_group', perm_members='$perm_members', perm_anon='$perm_anon', " .
				"user2='$user2', notes='{$notes}'");
			$c_id = DB_insertID();
			setRelation($companyID,$c_id,"ct_index");
		} else {
			if ($personID == 1) {
				DB_query("insert into ct_person set co_id=1, fname='', lname=''");
				$personID=DB_insertID();
			}
			DB_query("INSERT INTO ct_company SET p_id='{$personID}', name='$name', cdate=" . time() . "," .
				"address1='$address1', address2='$address2', city='$city', state='$state', " .
				"postalcode='$postalcode', country='$country', phone1='$phone1', phone2='$phone2', " .
				"fax='$fax', email1='$email1', email2='$email2', " .
				"url1='$url1', url2='$url2', date1=IF('$date1'='',NULL,'$date1'), date2=IF('$date2'='',NULL,'$date2'), user1='$user1', " .
				"owner_id='$owner_id', group_id='$group_id', perm_owner='$perm_owner'," .
				"perm_group='$perm_group', perm_members='$perm_members', perm_anon='$perm_anon', " .
				"user2='$user2', notes='{$notes}'");
			$c_id = DB_insertID();
			setRelation($c_id, $personID, "ct_index");
			DB_query("UPDATE ct_person set co_id=$c_id where c_id=$personID");
		}			 
	
	}
} elseif (($action == $LANG_CT05['delete']) && (SEC_hasRights('contact.delete'))) {
	if ($c_type == 1) {
		DB_query("DELETE FROM ct_person WHERE c_id=$c_id");
		DB_query("DELETE FROM ct_index where p_id=$c_id");
	} else {
		$R = DB_query("SELECT c_id from ct_person where ((co_id=$c_id) AND (fname='') AND (lname=''))");
		if (DB_numRows($R) > 0) {
			DB_query("DELETE FROM ct_person where c_id='" . $R['c_id'] . "'");
		}
		DB_query("DELETE FROM ct_company WHERE c_id=$c_id");
		DB_query("DELETE FROM ct_index where c_id=$c_id");
	}
	$c_id='';
	$c_type='';
} elseif ($action == "deleteR") {
	if ($c_type == 1) {
		DB_query("DELETE FROM ct_index WHERE ( p_id = $c_id ) && ( c_id = $did )");
	} else {
		$R = DB_query("SELECT c_id from ct_person where co_id=$c_id");
		if (DB_numRows($R) > 1) {
			DB_query("DELETE FROM ct_index WHERE ( p_id = $did ) && ( c_id = $c_id )");
		}
	}
} else {
	if (!isset($c_type)) { $c_type = 1; }
	if (!isset($c_id)) { $c_id=''; }
}

if ((isset($c_id))  && ($c_id != '')) {
	if ($c_type == 1) {
		$REC = DB_query("SELECT * FROM ct_person WHERE c_id=$c_id");
	} else {
		$REC = DB_query("SELECT * FROM ct_company WHERE c_id=$c_id");
	}
	if (DB_numRows($REC) > 0) {
		$A = DB_fetchArray($REC);
		$c_oid = $A['owner_id'];
	} else {
		$A = array ();
		$c_oid = $_USER['uid'];
	}
} else {
	$A = array ();
	$c_oid = $_USER['uid'];
}
	
	
if ($c_type == 1) {
	$FIELDS = $_CT_PERSON;
	$LANG = CT_getPFields();
} elseif ($c_type == 2) {
	$FIELDS = $_CT_COMPANY;
	$LANG = CT_getCFields();
} else {
	$FIELDS = array();
	$LANG = array();
}
$numf = count($FIELDS);

$T = new Template($_CONF['path'] . 'plugins/contact/templates');
$T->set_file('edit','edit.thtml');
$T->set_block('edit','Field','ABlock');
$T->set_block('edit','Relation','BBlock');
$T->set_var('header',$LANG_CT05['edit_contact']);
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('view',$LANG_CT05['view']);
$T->set_var('save',$LANG_CT05['save']);
$T->set_var('cancel',$LANG_CT05['cancel']);
$T->set_var('addp',$LANG_CT05['add_person']);
$T->set_var('addc',$LANG_CT05['add_company']);
if (((SEC_hasRights('contact.admin')) || ($A['owner_id'] == $_USER['uid'])) && (SEC_hasRights('contact.delete')) && ($c_id != '')) { 
	$T->set_var('delete',"<input type='submit' value='{$LANG_CT05['delete']}' name='action'> ");
}
if ((SEC_hasRights('contact.admin')) || ($c_id == '') || ($A['owner_id'] == $_USER['uid']) || ($action == $LANG_CT05['add_person']) || ($action == $LANG_CT05['add_company'] )){
	$T->set_var('lang_accessrights', $LANG_ACCESS[accessrights]);
	$T->set_var('lang_owner', $LANG_ACCESS[owner] . ':');
	if (SEC_inGroup('Root')) {
		$T->set_var('owner_username', '');
		$usrdd = '<SELECT name="owner_id">' . COM_optionList($_TABLES['users'],"uid,username",$c_oid) . "</SELECT>";
		$T->set_var('owner_id',$usrdd);
	} else {
		$T->set_var('owner_username', '&nbsp;&nbsp;&nbsp' . DB_getItem($_TABLES['users'],'username',"uid = {$c_oid}"));
		$T->set_var('owner_id', "<input type='hidden' name='owner_id' value='{$c_oid}'>");
	}
	$T->set_var('lang_group', $LANG_ACCESS['group'] . ':');
	$usergroups = SEC_getUserGroups();
	$groupdd .= '<SELECT name="group_id">';
	for ($i = 0; $i < count($usergroups); $i++) {
		$groupdd .= '<option value="' . $usergroups[key($usergroups)] . '"';
	    if ($A['group_id'] == $usergroups[key($usergroups)]) {
    		$groupdd .= ' SELECTED';
	    }
  		$groupdd .= '>' . key($usergroups) . '</option>';
	    next($usergroups);
	}
	$groupdd .= '</SELECT>';
	$T->set_var('group_dropdown', $groupdd);
	$T->set_var('lang_permissions', $LANG_ACCESS[permissions] . ':');
	$T->set_var('lang_perm_key', $LANG_ACCESS[permissionskey]);
	if (!in_array('perm_owner',$A)) {
		$A['perm_owner']=3;
	}
	$T->set_var('permissions_editor', SEC_getPermissionsHTML($A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']));
	$T->set_var('permissions_msg', $LANG_ACCESS[permmsg]);
	$T->set_var('hr','<hr>');
} else {
	// Perms editor not shown insert perm variables
	$T->set_var('owner_id', "<input type='hidden' name='owner_id' value='" . $A['owner_id'] . "'>");
	$tmpS = "<input='hidden' name='group_id' value='" . $A['group_id'] . "'>";
	$tmpS .= "<input='hidden' name='perm_owner' value='" . $A['perm_owner'] . "'>";
	$tmpS .= "<input='hidden' name='perm_group' value='" . $A['perm_group'] . "'>";
	$tmpS .= "<input='hidden' name='perm_members' value='" . $A['perm_members'] . "'>";
	$tmpS .= "<input='hidden' name='perm_anon' value='" . $A['perm_anon'] . "'>";
	$T->set_var('perms',$tmpS);
}

$T->set_var('c_id',$c_id);
$T->set_var('c_type',$c_type);
if ($c_type == 2) {
	$T->set_var('contact_type',$LANG_CT00['company']);
} elseif ($c_type == 1) {
	$T->set_var('contact_type',$LANG_CT00['person']);
} else {
	$T->set_var('contact_type',$LANG_CT00['contact']);
}
if ($c_id != '') {
	$T->set_var('rec_no'," $c_id");
}
for($i = 0; $i < $numf; $i++) {
	$$FIELDS[$i] = $A[$FIELDS[$i]];
	$T->set_var('field_label',$LANG["$FIELDS[$i]"]);
	$T->set_var('field_name',$FIELDS[$i]);
	if (($action == $LANG_CT05['add_person']) || ($action == $LANG_CT05['add_company'])) {
		$T->set_var('field_value','');
	} else {		
		$T->set_var('field_value',stripslashes($$FIELDS[$i]));
	}
	$T->Parse('ABlock','Field',true);
}
if (isset($c_type)) {
	$T->set_var('notes_label',$LANG['notes']);
	$T->set_var('notes_name','notes');
	$T->set_var('notes_value',stripslashes($A['notes']));
	$select = "<select size='1' width='40' name=";
	if ($c_type == 1) {
		$companyID = $A['co_id'];
		$result = DB_query("Select c_id, name, city, state FROM ct_company order by name");
		$nrows = DB_numRows($result);
		$retval="";
    	for ($i = 0; $i < $nrows; $i++) {
			$A = DB_fetchArray($result);
	        $retval .= '<option value="' . $A[0] . '"';
    	    if ($A[0] == $companyID) {
        		$retval .= ' selected';
	        }          
    	    $tmp = substr($A[1] . ' - ' . $A[2] . ', ' . $A[3],0,39);
        	$retval .= '>' . $tmp . '</option>' . LB;
	    }         
		$T->set_var('assoc_label',$LANG_CT00['company']);
		$select .= "'companyID'>" . $retval ."</select>";
	} else {
		$personID = $A['p_id'];
		$result = DB_query("Select c_id, fname, lname, city FROM ct_person where ((fname!='') || (lname!='') || (c_id=1)) order by lname");
		$nrows = DB_numRows($result);
		$retval="";
    	for ($i = 0; $i < $nrows; $i++) {
			$A = DB_fetchArray($result);
	        $retval .= '<option value="' . $A[0] . '"';
    	    if ($A[0] == $personID) {
        		$retval .= ' selected';
	        }
	        $tmp = substr($A[1] . ' ' . $A[2] . ' - ' . $A[3],0,39);
    	    $retval .= '>' . $tmp . '</option>' . LB;
	    }
    	$T->set_var('assoc_label',$LANG_CT00['person']);
		$select .= "'personID'>" . $retval ."</select>";
	}
}
if (($c_type == 1) && ($c_id != '')) {
	$REL = DB_query("SELECT ct_company.* from ct_company, ct_index  where (ct_company.c_id = ct_index.c_id) && ct_index.p_id = $c_id");
	$numrel = DB_numRows($REL);
	for ($i=0;$i<$numrel;$i++) {
		$A=DB_fetchArray($REL);
		if ($companyID == $A['c_id']) {
			$T->set_var('relation_label',$LANG_CT06['mcompany']);
		} else {
			$T->set_var('relation_label',$LANG_CT06['ocompany']);
		}
		$T->set_var('relation_name',stripslashes($A['name'] . " -- " . $A['city'] . ", " . $A['state']));
		$T->set_var('deleteR',$LANG_CT06['deleter']);
		$T->set_var('rid',$A['c_id']);
		$T->set_var('rtype',2);
		$T->set_var('hrr','<hr>');
		$T->Parse('BBlock','Relation',true);
	}
} elseif ($c_id!='') {
	$REL = DB_query("SELECT ct_person.* from ct_person, ct_index  where (ct_person.c_id = ct_index.p_id) && ct_index.c_id = $c_id");
	$numrel = DB_numRows($REL);
	for ($i=0;$i<$numrel;$i++) {
		$A=DB_fetchArray($REL);
		if ($personID == $A['c_id']) {
			$T->set_var('relation_label',$LANG_CT06['mperson']);
		} else {
			$T->set_var('relation_label',$LANG_CT06['operson']);
		}
		$T->set_var('relation_name',stripslashes($A['fname'] . " " . $A['lname'] . " -- " . $A['city'] . ", " . $A['state']));
		$T->set_var('deleteR',$LANG_CT06['deleter']);
		$T->set_var('rid',$A['c_id']);
		$T->set_var('rtype',1);
		$T->set_var('hrr','<hr>');
		$T->Parse('BBlock','Relation',true);
	}
}
$T->set_var('assoc',$select);
$T->parse('output','edit');
$display .= $T->finish($T->get_var('output'));

$display .= COM_siteFooter(true);

echo $display;

                                                                                    
?>