<?php

//
// +---------------------------------------------------------------------------+
// | Contact Geeklog Plugin 1.1                                                |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// | This is the main page for the Geeklog Contact Plugin                      |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett           -  tomw@pigstye.net                        |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');


/*
* Main Routine Displays contacts which are available to user
*/

if (empty($_USER['uid'])) {
	$_USER['uid']=1;
	$_USER['username']='Anonymous';
}

// Only let users with view rights access this page
if ((!SEC_hasRights('contact.view')) && ($_CONTACT_CONF['contact_anon'] != '1')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Contacts page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
	print COM_refresh($_CONF['site_url'] . '/index.php');
    exit;
}

/*
* Returns html for search option box
*
*/
function searchOption() {
	global $_CT_COMPANY, $LANG_CT00;
	
	$retval = "<select size=1 name='search'><option value='0'></option>";
	$fld = CT_getPFields();
	foreach ($fld as $key => $value) {
		if ($key != 'name') {
			$retval .= "<option value='$key'>$value</option>";
		}
	}
	$fld = CT_getCFields();
	foreach ($_CT_COMPANY as $key) {
		$retval .= "<option value='xx{$key}'>" . $LANG_CT00['company'] . " " . $fld["$key"] . "</option>";
	}
	$retval .= "</select>";
	return $retval;
}

$recs = DB_query("SELECT * FROM ct_user where u_id = '" . $_USER['uid'] . "'");
if (DB_numRows($recs) > 0) {
	$userPrefs = DB_fetchArray($recs);
	$userFields = explode(",",$userPrefs['viewfields']);
	$userFieldsNum = count($userFields);
} else {
	$userPrefs = array ( 'u_id' => $_USER['uid'],
						 'perpage' => $_CONTACT_CONF['perpage'],
						 'viewfields' => $_CONTACT_CONF['viewfields'],
						 'view' => $_CONTACT_CONF['view']);
	$userFields = explode(",",$userPrefs['viewfields']);
	$userFieldsNum = count($userFields);
}


if ($userPrefs['view'] == 1) {
	$ind_temp = "index.thtml";
	$mode_flg=true;
} else {
	$ind_temp = "indexw.thtml";
	$mode_flg=false;
}

if ($userPrefs['wide'] == '1') {
	$wide = 'none';
} else {
	$wide = 'menu';
}

$LANGP = CT_getPFields();
$LANGC = CT_getCFields();
CT_contactAddHit();
$retval = COM_siteHeader($wide);
$T = new Template($_CONF['path'] . 'plugins/contact/templates/');  
$T->set_file('index',$ind_temp);  
if (!$mode_flg) {
	$T->set_block('index','Field','BBlock');
}
$T->set_block('index','Contact','ABlock');
$T->set_var('header',$LANG_CT00['contacts']);
$T->set_var('view',$LANG_CT05['view']);
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('search',searchOption());
$T->set_var('search_lang','Search');
if ($_USER['uid'] > 1) {
	$T->set_var('add_msg','<img src="' . $_CONF['site_url'] . '/contact/images/new.gif" border="0" alt="' . $LANG_CT06['add_contact'] . '">'); 
	$T->set_var('option_msg', '<img src="' . $_CONF['site_url'] . '/contact/images/options.gif" border="0" alt="' . $LANG_CT06['options'] . '">');
}
if (empty($sort)) {
	$orderby = '';
	$orderbyc = '';
} else {
	$orderby = " ORDER BY $sort $direction";
	if ((substr($sort,0,1) == "c") && ($sort != 'city')) {
		$orderbyc = " ORDER BY " . substr($sort,1) . " $direction";
	} else {
		$orderbyc = "";
	}
}
$where = CT_getPerms('p') . " AND " . CT_getPerms('c');
if (isset($search)) {
	if ($search != '0') {
		$search = str_replace("xx", "c.", $search);
		$where .= " AND (" . $search . " like '%{$crit}%')";
	} else {
		$where .= " AND (";
		foreach($_CT_PERSON as $key) {
			$where .= "(p." . $key . " like '%{$crit}%') OR ";
		}
		foreach($_CT_COMPANY as $key) {
			$where .= "(c." . $key . " like '%{$crit}%') OR";
		}
		$where = substr($where,0,strlen($where)-2) . ")";
	}
}
$RECS = DB_query("Select p.*, c.c_id as cc_id, c.name as cname, c.address1 as caddress1, c.address2 as caddress2,"
	. " c.city as ccity, c.state as cstate, c.postalcode as cpostalcode,"
	. " c.country as ccountry, c.phone1 as cphone1, c.phone2 as cphone2, c.email1 as cemail1,"
	. " c.fax as cfax, c.email2 as cemail2, c.url1 as curl1, c.url2 as curl2, c.date1 as cdate1,"
	. " c.date2 as cdate2, c.user1 as cuser1, c.user2 as cuser2, c.notes as cnotes"
	. " from ct_person as p, ct_company as c where (p.co_id = c.c_id) AND " . $where . " $orderby");
$nrows = DB_numRows($RECS);
$contacts = $nrows;
if (empty($page)) {
	$page = 0;
}
if ($page > 0) {
	$start = (($page - 1) * $userPrefs['perpage'] +1);
} else {
	$page = 1;
	$start = 1;
}
$end = $start + $userPrefs['perpage'];
if ($contacts < $end) {
	$end = $contacts;
}


if (!$mode_flg) {
	$T->set_var('cont_head','');
	$upimg = "<img src='" . $_CONF['site_url'] . "/contact/images/arrow_up.gif'>";
	$downimg = "<img src='" . $_CONF['site_url'] . "/contact/images/arrow_down.gif'>";
	if ((empty($direction)) || ($direction == "DESC")) {
		$direction = "ASC";
	} else {
		$direction = "DESC";
	}
	$T->set_var('field','&nbsp');
	$T->Parse('BBlock','Field',true);
	foreach($userFields as $avalue) {
		$bvalue = $LANGP["$avalue"];
		if (empty($bvalue)) {
			$bvalue = substr($avalue,1);
			$bvalue = $LANG_CT00['company'] . " " .$LANGC["$bvalue"];
		}
		if (isset($page)) { $other_ops = "&page=$page"; }
		if (isset($search)) { $other_ops .= "&search=" . urlencode($search) . "&crit=" . urlencode($crit); }
		$tmp = "<a href='" . $_CONF['site_url'] . "/contact/index.php?sort=" . $avalue . "&direction=" . $direction . $other_ops . "'><b>" . $bvalue . "</b></a>";
		if ($sort == $avalue) {
			if ($direction == "ASC") {
				$tmp .= $downimg;
			} else {
				$tmp .= $upimg;
			}
		}
		$T->set_var('field',$tmp);
		$T->Parse('BBlock','Field',true);
	}		
	$T->Parse('ABlock','Contact',true);
}
if ($end < $nrows) {
	$nrows = $end;
}
for ($i=1; $i <= $nrows; $i++) {
	$A = DB_fetchArray($RECS);
	if (($A['c_id'] != 1) && ($i >= $start)) {
		if (SEC_hasRights('contact.edit')) {
			$cont_head = "<a href=" . $_CONF['site_url'] . "/contact/edit.php?c_id=" . $A['c_id'] . "&c_type=1>" 
						. '<img src="' . $_CONF['site_url'] . '/contact/images/edit.gif" border="0" alt="' . $LANG_CT06['edit'] . '"></a>';
		} else {
			$cont_head = '';
		}
		if ($mode_flg) {		// Full Listing
			$cont_head = $A['fname'] . " " . $A['lname'] . "&nbsp&nbsp&nbsp" . $cont_head;
			$T->set_var('cont_head',COM_startBlock($cont_head));
			foreach($A as $akey => $avalue) {
				if ((($akey == 'city') || ($akey == 'ccity')) && (!empty($avalue))){ $avalue = $avalue . ','; }
				$T->set_var("$akey",stripslashes($avalue));
			}
			$T->set_var('cont_foot',COM_endBlock());
		} else {		// Brief Listing
			$T->set_var('cont_head','<tr><td colspan="' . ($userFieldsNum + 1) . '"><hr></td></tr>');
			$T->set_var('BBlock','');
			$T->set_var('field','<a href="' . $_CONF['site_url'] . '/contact/viewp.php?c_id=' . $A['c_id'] . '">' . "<img src='" . $_CONF['site_url'] . "/contact/images/specs.gif' border='0'></a>");
			$T->Parse('BBlock','Field',true);
			foreach($userFields as $avalue) {
				if ($avalue == 'cname') {
					$T->set_var('field','<a href="' . $_CONF['site_url'] . '/contact/viewc.php?c_id=' . $A['co_id'] . '">' . stripslashes($A["$avalue"]) . '</a>');
				} else {
					$T->set_var('field',stripslashes($A["$avalue"]));
				}
				$T->Parse('BBlock','Field',true);
			}		
		}
		$T->Parse('ABlock','Contact',true);
	}
}

$pages = (int) (($contacts - 1) / $userPrefs['perpage']);
if ((($contacts - 1) % $userPrefs['perpage']) > 0 ) {
	$pages++;
}
if (isset($sort)) {
	if ($direction == "ASC") {
		$parms="?sort={$sort}&direction=DESC";
	} else {
		$parms="?sort={$sort}&direction=ASC";
	}
} else {
	$parms = '';
}
if (isset($search)) {
	if ($parms == '') { $parms='?'; } else { $parms='&'; }
	$parms .= "search=" . urlencode($search) . "&crit=" . urlencode($crit);
}
	
if ($contacts > $userPrefs['perpage']) {
	$T->set_var('pagenavigation',COM_printPageNavigation($_CONF['site_url'] . "/contact/index.php{$parms}",$page,$pages));
}
$T->parse('output','index');  
$retval .= $T->finish($T->get_var('output'));  

if (($userPrefs['view'] == 0) || ($userPrefs['wide'] == '1')) {
	$right = false;
} else {
	$right = true;
}

$retval .= COM_siteFooter($right);
echo $retval;

?>