<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Contact Geeklog Plugin 1.1                                                |
// +---------------------------------------------------------------------------+
// | options.php                                                               |
// | This is the user options page for the Geeklog Contact Plugin              |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett           -  tomw@pigstye.net                        |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

/* 
* Redirect User if they are not logged in
*/

// Only let users with view rights access this page
if (!SEC_hasRights('contact.edit,contact.delete','OR')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Contacts user options page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
	print COM_refresh($_CONF['site_url'] . '/index.php');
    exit;
}

/*
* Main Routine Displays option page for user
*/

if ($action == $LANG_CT00['save']) {
	foreach($_CT_PERSON as $tmp) {
		if (!empty($$tmp)) {
			$st .= $$tmp . ",";
		} 
	}
	foreach($_CT_COMPANY as $tmp) {
		$tmp = 'c' . $tmp;
		if (!empty($$tmp)) {
			$st .= $$tmp . ",";
		} 
	}
	$st = substr($st,0,strlen($st)-1);
	if ($wide == 'wide') {
		$wide = '1';
	} else {
		$wide = '0';
	}
	$A['viewfields']=$st;
	$A['view']=$view;
	$A['perpage']=$perpage;
	$A['wide'] = $wide;
	$user = $_USER['uid'];
	db_query("UPDATE ct_user SET perpage = '$perpage', view = '$view', viewfields = '$st', wide = '$wide' WHERE u_id='$user'");
} else {
	$RECS = DB_query("SELECT * FROM ct_user WHERE u_id='{$_USER['uid']}';");
	if (DB_numRows($RECS) > 0) {
		$A = DB_fetchArray($RECS);
	} else {
		//default if have not set preferences
		$A['perpage']=$_CONTACT_CONF['perpage'];
		$A['viewfields']=$_CONTACT_CONF['viewfields'];
		$A['view']=$_CONTACT_CONF['view'];
		$A['wide']=$_CONTACT_CONF['wide'];
		DB_query("INSERT INTO ct_user VALUES ('{$_USER['uid']}','{$A['perpage']}','{$A['viewfields']}','{$A['view']}','{$A['wide']}')");
	}
}
$display = COM_siteHeader();

$T = new Template($_CONF['path'] . 'plugins/contact/templates/');
$T->set_file('options','options.thtml');
$T->set_block('options','Field','ABlock');
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('view',$LANG_CT05['view']);
$T->set_var('editc_msg',$LANG_CT04['edit_msg']);
$T->set_var('viewc_msg',$LANG_CT04['view_msg']);
$T->set_var('header',$LANG_CT04['header']);
$T->set_var('t_perpage',$LANG_CT04['perpage']);
$T->set_var('per_page',$A['perpage']);
$T->set_var('compact',$LANG_CT04['compact']);
$T->set_var('full',$LANG_CT04['full']);
if ($A['view'] == '1') {
	$T->set_var('fcheck','checked ');
} else {
	$T->set_var('ccheck','checked ');
}
if ($A['wide'] == '1') {
	$T->set_var('wchecked','checked');
} else {
	$T->set_var('wchecked','');
}
$T->set_var('w_title',$LANG_CT04['wide']);

$T->set_var('c_head',$LANG_CT04['c_head']);
$T->set_var('person',$LANG_CT00['person']);
$T->set_var('company',$LANG_CT00['company']);

$LANGP = CT_getPFields();
$LANGC = CT_getCFields();
$n = count($LANGP);


$nump = count($_CT_PERSON);
$numc = count($_CT_COMPANY);
for ($i = 0; $i < $nump; $i++) {
	$T->set_var('p_value',$_CT_PERSON[$i]);
	if (preg_match("/\b$_CT_PERSON[$i]\b/",$A['viewfields'])) {
		$T->set_var('p_check',' checked');
	} else {
		$T->set_var('p_check','');
	}
	$T->set_var('p_title',$LANGP[$_CT_PERSON[$i]]);

	if (preg_match("/\bc$_CT_COMPANY[$i]\b/",$A['viewfields'])) {
		$T->set_var('c_check',' checked');
	} else {
		$T->set_var('c_check','');
	}
	if ($i < $numc) {
		$T->set_var('c_value','c' . $_CT_COMPANY[$i]);
		$T->set_var('c_title',$LANGC[$_CT_COMPANY[$i]]);
		$T->set_var('in_type','checkbox');
	} else {
		$T->set_var('in_type','hidden');
		$T->set_var('c_title','');
		$T->set_var('c_field','');
		$T->set_var('c_value','');
	}
    $T->Parse('ABlock','Field',true);
}
$T->set_var('save',$LANG_CT00['save']);
$T->set_var('cancel',$LANG_CT00['cancel']);
$T->parse('output','options');
$display .= $T->finish($T->get_var('output'));

$display .= COM_siteFooter(true);
echo $display;

?>
