<?php

//
// +---------------------------------------------------------------------------+
// | Contact Geeklog Plugin 1.1                                                |
// +---------------------------------------------------------------------------+
// | viewc.php                                                                 |
// | This is the view company page for the Geeklog Contact Plugin              |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett           -  tomw@pigstye.net                        |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');


if (empty($_USER['uid'])) {
	$_USER['uid']=1;
	$_USER['username']='Anonymous';
}

// Only let users with view rights access this page
if ((!SEC_hasRights('contact.view')) && ($_CONTACT_CONF['contact_anon'] != '1')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Contacts page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
	print COM_refresh($_CONF['site_url'] . '/index.php');
    exit;
}

$retval = COM_siteHeader();

$template = "viewc.thtml";
$T = new Template($_CONF['path'] . 'plugins/contact/templates/');  
$T->set_file('index',$template);  
$T->set_block('index','Person','ABlock');
$T->set_var('header',$LANG_CT00['contacts']);
$T->set_var('view',$LANG_CT05['view']);
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('layout_url',$_CONF['layout_url']);
if ($_USER['uid'] > 1) {
	$T->set_var('add_msg','<img src="' . $_CONF['site_url'] . '/contact/images/new.gif" border="0" alt="' . $LANG_CT03['addedit'] . '">');
	$T->set_var('option_msg',$LANG_CT06['options']);
}
$RECS = DB_query("Select * from ct_company where (c_id = '{$c_id}') AND " . CT_getPerms());
$nrows = DB_numRows($RECS);

if ($nrows > 0) {
	CT_contactHit($c_id,'ct_company');
	$A = DB_fetchArray($RECS);
	$access = SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);	
	if ($A['c_id'] != 1) {
		$T->set_var('contact_name',$A['name']);
		$T->set_var('c_id',$A['c_id']);
		if ((SEC_hasRights('contact.edit')) && ($access == 3)) {
			$T->set_var('edit_img','<img src="' . $_CONF['site_url'] . '/contact/images/edit.gif" border="0" alt="' . $LANG_CT06['edit'] . '">');
		}
		$T->set_var('prt_alt',$LANG01[65]);
		foreach($A as $akey => $avalue) {
			$T->set_var("$akey",stripslashes($avalue));
		}
		$LANG = CT_getCFields();
		foreach($LANG as $akey => $avalue) {
			if ($A["$akey"] != '') { $T->set_var("{$akey}_label","$avalue"); }
		}
	}
	$T->set_var('view_lang',$LANG_CT06['views']);
	$T->set_var('views',$A['hits']);
	$T->set_var('cdate_lang',$LANG_CT06['created']);
	$T->set_var('cdate',strftime( "%x", strtotime($A['cdate'])));
	// load related people
	$RECS = DB_query("SELECT ct_person.* from ct_person, ct_index  where (ct_person.c_id = ct_index.p_id) AND (ct_index.c_id = $c_id) AND " . CT_getPerms());
}

// now show related people
$nrows = DB_numRows($RECS);
for ($i=0; $i < $nrows; $i++) {
	$B = DB_fetchArray($RECS);
	if ($B['c_id'] != '1') {
		if ($B['c_id'] == $A['p_id']) {
			$T->set_var('company_label',$LANG_CT06['mperson']);
		} else {
			$T->set_var('company_label',$LANG_CT06['operson']);
		}
		foreach($B as $akey => $avalue) {
			$T->set_var("p{$akey}",stripslashes($avalue));
		}
		$LANG = CT_getPFields();
		foreach($LANG as $akey => $avalue) {
			if ($B["$akey"] != '') { $T->set_var("p{$akey}_label","$avalue"); }
		}
	    $T->Parse('ABlock','Person',true);
	}
}
$T->parse('output','index');  
$retval .= $T->finish($T->get_var('output'));  

$right_blocks = true;
$retval .= COM_siteFooter($right_blocks);
echo $retval;

?>